/*
   Small library of useful utilities based on the dietlib by fefe
   Copyright (C) 2003, 2008 Andreas Franz Borchert
   --------------------------------------------------------------------
   This library is free software; you can redistribute it and/or modify
   it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef AFBLIB_PACKETIZER_H
#define AFBLIB_PACKETIZER_H

#include <stralloc.h>
#include <netinet/in.h>
#include <afblib/multiplexor.h>

typedef struct session {
   void* handle; /* can be freely used by the application */
   stralloc request;
   stralloc response;
   connection* link; /* private field */
} session;

typedef void (*request_handler)(session* s);
typedef void (*hangup_handler)(session* s);

void send_response(session* s);
void close_session(session* s);
void run_mpx_service(in_port_t port,
   request_handler rhandler, hangup_handler hhandler);

#endif
