/*
   Small library of useful utilities based on the dietlib by fefe
   Copyright (C) 2003, 2008 Andreas Franz Borchert
   --------------------------------------------------------------------
   This library is free software; you can redistribute it and/or modify
   it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/*
 * Data structure for dynamic string lists that works
 * similar to the stralloc library.
 * Return values: 1 if successful, 0 in case of failures.
 * afb 4/2003
 */

#ifndef AFBLIB_STRLIST_H
#define AFBLIB_STRLIST_H

typedef struct strlist {
   char** list;
   unsigned int len; /* # of strings in list */
   unsigned int allocated; /* allocated length for list */
} strlist;

/* assure that there is at least room for len list entries */
int strlist_ready(strlist* list, unsigned int len);

/* assure that there is room for len additional list entries */
int strlist_readyplus(strlist* list, unsigned int len);

/* truncate the list to zero length */
int strlist_clear(strlist* list);

/* append the string pointer to the list */
int strlist_push(strlist* list, char* string);
#define strlist_push0(list) strlist_push((list), 0)

/* free the strlist data structure but not the strings */
int strlist_free(strlist* list);

#endif
